function [ C ] = code_ab(x ,n , a ,b)
    %CODE_AB returns the binary code of the entered number. Number of digits
    %and ab interval is also taken into account
    % x-->char / int       ---> value to be coded to binary, x[a,b] is a must
    % n-->int     OPTIONAL ---> number of digits of the binary code  
    % a-->numeric OPTIONAL ---> lower bound of interval
    % b-->numeric OPTIONAL ---> upper bound of interval
    %IMPORTANT: function has to be called with 4 arguments at least once
    %before calling it with only one argument, as persistent values need to
    %be set.
    
    
    persistent per_abd;
    persistent persistent_n;
    
    
    %NARGIN 1
    if nargin  == 1
        
        %if x is not an string
        if not(ischar(x))
            
            %if x is not a string nor a number ---> error
            if not(isnumeric(x))
                error('x is not numeric nor string')
            end
            %check if x  [a,b] , else  --> error
            if per_abd(1) <= x && per_abd(2) >= x
                %code with phyton module, output is phyton string.
                %we then convert phyton string to matlab string
                C_string = char(py.phyton.bigint.code(x,persistent_n,per_abd(1),per_abd(2)));
                %finally, we evaluate function
                C = eval(C_string);
            else
                error(' x[a,b] is not true ')
            end
            
        else
            %try to call code_ab with a converted string
            C = code_ab(num2str(x,'%100.30f'));

                
        end
        
     
            
        
        
       

    %NARGIN 4   
    %set persistent values for ab and n    
    elseif nargin == 4       
        
        %error check a > b
        if a > b
            error(' b > a on [a,b] interval')
        end
    
        per_abd = [a, b , b-a] ;
        persistent_n = n;
        
        C = code_ab(x);
    end
    
end



