function [ x ] = decode_ab( C ,n , a , b )
    %DECODE_AB returns the binary code of the entered number. Number of digits
    %and ab interval is also taken into account
    % C-->char / mat of doubles  ---> value to be decoded to decimal
    % n-->int     OPTIONAL       ---> number of digits of the binary code  
    % a-->numeric OPTIONAL       ---> lower bound of interval
    % b-->numeric OPTIONAL       ---> upper bound of interval
    %IMPORTANT: function has to be called with 4 arguments at least once
    %before calling it with only one argument, as persistent values need to
    %be set.
    
    persistent per_abd;
    persistent persistent_n;
    
    %Nargin1
    %decode C
    if nargin  == 1
        if ischar(C)
            x = eval(char(py.phyton.bigint.decode( C ,persistent_n,per_abd(1),per_abd(2))));
        elseif isnumeric(C)
            a = mat2str(C); %vector ----> str [1 2 3] --->str [1,2,3]
            x =  decode_ab(strrep(a,' ',',')); 

        end

    

        
    %NARGIN 4   
    %set persistent values for ab and n    
    elseif nargin == 4       
        
        
        if a > b
            error(' b > a on [a,b] interval')
        end
        per_abd = [a , b] ;
        persistent_n = n;  
        x = decode_ab(C);
        
    end
    



end

