function [ population ] = main( txtfile, rep_len, pop_size, i_max )

% use nextline.m to read the txtfile 
clear nextline
mode         = nextline(txtfile);
fitness_opts = nextline(txtfile);
fitness_opts = eval(fitness_opts);
fitness_mode_opts = {mode,fitness_opts{:}};
len               = eval(nextline(txtfile));
popsize           = eval(nextline(txtfile));
imax              = eval(nextline(txtfile));

% uncoment these lines to override data.txt values with input values
%len = rep_len;
%popsize = pop_size;
%imax = i_max;

switch mode
	
    %Uniparametric function mode
    case 'function_max' 
        C = zeros(1,len);

        %Initialize population with randpop, and write mode_fitness_opts on popultion
        population = randpop(C,popsize,fitness_mode_opts);

        close all % close all previous figures 
        hold all
            
        %we create two points to name the legends, make room for legends, and preallocate x axis
        scatter(0,0,'.','red')
        scatter(0,imax,'.','blue')
        legend('Max. fitness','Mean fitness','Location','southeast')
            
        for i = 1:imax
            matingpool = select_ga(population);
            matedpool = crossover(matingpool);
            population.pop = mutate(matedpool);    
            scatter(i,population.bestfitness,'.','MarkerEdgeColor','red')
            scatter(i,population.meanfitness,'.','MarkerEdgeColor','blue')
            drawnow
        end

        %plot function and found maxima
        figure
        a = fitness_mode_opts{2};
        b = fitness_mode_opts{3};
        f = fitness_mode_opts{4};
        x = decode_ab(population.bestpopindividual.chrompack.genome,length(C),a,b);
        hold all

	        
	mindist = min([x-a,b-x]);
        xmax = fminbnd(@(x) -f(x),x - (mindist/1000),x + (mindist/1000));
        %xmax = -8.3778;

        plot(a:(b-a)/100000:b,f(a:(b-a)/100000:b))
        %ga maximun
        plot(xmax, f(xmax), 'ro', 'markersize', 4)
        plot([xmax-0.1, xmax-0.1], ylim,'color',[0 0.6 0.3]) 
        plot([xmax+0.1, xmax+0.1], ylim,'color',[0 0.6 0.3]) 
        legend('f1','maxima','convergence area','Location','southeast')

        disp('error: ')
	disp( abs(f(xmax) - f(x)) )	

	% code below used to measure the probability of terminating the algorithm on the conv area        
	%if  0.1 > abs(x - xmax)
        %    population = 1;
        %else
        %    population = 0;
        %end
        %hold off
        %fclose all;
	population = {x, f(x)}


    %Biparametric function mode
    case 'multiparam_max'
        C = zeros(2,len);
        %Initialize population with randpop, and write mode_fitness_opts on popultion
        population = randpop(C,popsize,fitness_mode_opts);
        hold all

        %we create two points to name the legends, make room for legends, and
        %preallocate x axis

        scatter(0,0,'.','red')
        scatter(0,imax,'.','blue')
        legend('Max. fitness','Mean fitness','Location','southeast')
        for i = 1:imax
            matingpool = select_ga(population);
            matedpool = crossover(matingpool);
            population.pop = mutate(matedpool);    
            scatter(i,population.bestfitness,'.','MarkerEdgeColor','red')
            scatter(i,population.meanfitness,'.','MarkerEdgeColor','blue')
            drawnow
                 
        end
        hold off
        figure
        a1 = fitness_mode_opts{2};
        b1 = fitness_mode_opts{3};
        a2 = fitness_mode_opts{4};
        b2 = fitness_mode_opts{5};
        f  = fitness_mode_opts{6};
        x  = decode_ab(population.bestpopindividual.chrompack.genome(1,:),length(C(1,:)),a1,b1);
        y  = decode_ab(population.bestpopindividual.chrompack.genome(2,:),length(C(2,:)),a2,b2);
        
	% uncomment to plot found best solution        
        disp({x,y,f(x,y)})
            
        x_vect = linspace(a1,b1,1000);
        y_vect = linspace(a2,b2,1000);
            
        [x_mesh, y_mesh] = meshgrid(x_vect, y_vect);
            
        z_mesh = f(x_mesh,y_mesh);
            
        mesh(x_mesh, y_mesh, z_mesh)
        hold all
            
        %uncomment to plot inverted himmelblau's maxima 
	%plot3( 3.5804, -1.8200, 200, 'k.','MarkerSize', 25)
        %plot3(-2.8077, 3.1340, 200,'k.','MarkerSize', 25)
        %plot3(2.9905, 2.0118 ,200,'k.','MarkerSize', 25)
        %plot3(-3.7767, -3.2761,200,'k.','MarkerSize', 25)

	%we return the found best point
        population = {x,y,f(x,y)};
            

	%hold off
        %fclose all;


end




