from decimal import *  #we need this module so that we can reduce the numerical error in code/decode functions
from math import floor
getcontext().prec = 100 #we set default precision to 100 (which is very high)







#####################################################################################
###################        CODE                   ###################################
#####################################################################################


#return the binary code of an integer string (decimal integer)



def code(*args):

    ####code(x)####
    # x      ---> integer
    # output ---> list of 0 and 1 integers
    
    if len(args) == 1:
        
        #calculate binary string
        binary_string = bin(int(args[0]))
        #return an integer list 
        return [int(x) for x in binary_string.split('b')[1]]




        

    ####code(x,n)####
    # x      ---> integer
    # n      ---> integer [number of digits we want on binary code]
    # output ---> list of 0 and 1 integers
    
    elif len(args) == 2:

        
        
        #calculate code(x)
        C = code(int(args[0]))
        
        #convert n to int to avoid problems
        n = int(args[1])
        
        #check if n too small, if not return C with zeroes at the begining 
        if len(C) > n:
            print('len(c): '+str(len(C)))
            print('n: '+str(n))

            raise ValueError("len(C) > n , n is too small")
        else:
            dif = n - len(C)
            return  [0]*dif + C


 




     
    ####code(x,n,a,b)####
    # x      ---> float    ,  x€[a,b]] 
    # n      ---> integer  ,  number of digits we want on binary code
    # a      ---> float    ,  lower bound of interval
    # b      ---> float    ,  upper bound of interval
    # output ---> list of 0 and 1 integers
    
    elif len(args) == 4:

        getcontext().prec = int(floor(args[1]/4)) + 100
        x = Decimal(args[0])
        #convert n to int to avoid problems
        n = int(args[1])        
        a = Decimal(args[2])
        b = Decimal(args[3])

        #set precision
        #10**n is a upper bound of (2**4)**n = 8**n   

        getcontext().prec = int(floor(n/4)) + 100

        
        return str(code(   int(      (Decimal(x) - Decimal(a))  /  (Decimal(b) - Decimal(a))  *  Decimal(2 ** n - 1)     )    ,    n ))




#####################################################################################
###################        DECODE                   #################################
#####################################################################################


def decode(*args):

    #### decode(C)####
    # C      ---> binary list
    # output ---> integer
    
    if len(args) == 1:
        C = args[0]
        n = len(C)
        # [1,1,0,1] = sum([ 2^3 , 2^2 , 2^0]
        return   int(sum([2**(n - j - 1) for j in range(n) if C[j]]))






    #### decode(C,n,a,b)####
    # C      ---> binary list string ,  so that we can easily import an array from matlab
    # n      ---> integer            ,  number of digits we have on binary code
    # a      ---> float              ,  lower bound of interval
    # b      ---> float              ,  upper bound of interval
    # output ---> string(Decimal)

    if len(args) == 4: #n  = len(C) , however, we add it as an input argument for consistency with code calls 

        getcontext().prec = int(floor(args[1]/4)) + 100   
        C = eval(str(args[0]))
        n = int(args[1])
        a = Decimal(args[2])
        b = Decimal(args[3])

        if not(len(C) == n):
            raise ValueError("len(C) and n missmatch ")
        
        x = Decimal(decode(C))

        # return value on sring format, without scientific notation
        return format(       Decimal(a + ( x  / (2**n - 1) * (b - a)))           , 'f')















        

