classdef Individual < handle
    %INDIVIDUAL an individual of the population
    
    
    properties
        chrompack
        fitnessval = nan;
        
        
    end

    methods
        
        %fitness(obj) calculates the fitness value of the individual
        
        function r=fitness(obj,fitness_mode_opts)
             if isnan(obj.fitnessval) 
                 obj.fitnessval=fitness(obj.chrompack,fitness_mode_opts);
             end              
                 r=obj.fitnessval;                
        end
        
        
        %constructor checks if genome provided in which case creates obj,
        %constructor checks if given argument is a genome (matrix) or a
        %chrompack (Chrompack object) and creates individual accordingly
        
        
        function obj = Individual(information)
            if nargin == 0
            elseif nargin == 1
                len = length(information);
                if isa(information,'Chrompack') 
                    if len == 1;
                        obj.chrompack = information;
                    else
                        warning('use individualize method from Chrompack class instead')
                    end
                elseif isa(information,'double')
                    obj.chrompack = Chrompack(information);
                end                                             
            end 
        end 
    end
end

