
classdef Population < handle
    
    properties
        pop
        popsize = 0;
        bestpopindividual
        bestfitness = -10^30;
        meanfitness = 0 ;
        fitness_mode_opts
        
    end
    
    methods
        
        %after checking an Individual is given, adds it to the population
        function addindividual(obj,indiv) 
            if not(isa(indiv,'Individual'))
                error('addindividual method can only add Individual objects to Population.pop')
            end
            obj.pop=[obj.pop , indiv];       %add indiv to pop
            obj.popsize = obj.popsize + 1; %increment by 1 popsize
            %fitness(obj.pop);             %fitnnes can be calculated upon
                                           %addition, sacrificing speed
                                
             
            
            
        end
        
        
        %constructor checks type of input and creates obj
        %acepted inputs --->  Individual / Individual array

        function obj=Population(Individual_array , fitness_mode_opts)
            if nargin > 0               
                if isa(Individual_array(1),'Individual')
                    obj.pop=Individual_array;
                else
                    error('Pupulation constructor can only get Individual arrays as input')               
                end
                obj.popsize = obj.popsize + length(Individual_array);
                obj.fitness_mode_opts  = fitness_mode_opts;
                %fitness(obj);
            end 
        end
        
        %we calculate the the fitness of the entire population and save the
        %best individual, and its fitness. We also calculate the mean
        %fitness and the number of individuals
        
        function fitvector = fitness(obj)
            %calculate fitness only if not previously calculated
            fitvector=arrayfun(@(x)x.fitness(obj.fitness_mode_opts), obj.pop);  
            [maxf,maxindex]=max(fitvector);
            obj.meanfitness=sum(fitvector)/obj.popsize;

            if  obj.bestfitness < maxf 
                obj.bestfitness=maxf;
                obj.bestpopindividual=obj.pop(maxindex);                         
            end
            
            
        end
        
        
        
    end
    
    
    
    
end

