function [ fitness , error ] = calculatefitness( genome , fitness_mode_opts, calc_error )
    
    

    if ~exist('calc_error','var')
     % third parameter does not exist, so default it to something
      calc_error = false;
    end
   
    mode = fitness_mode_opts{1};
    

    switch mode
        case 'function_max'
            fitness  = function_max(genome,fitness_mode_opts);
        case 'pol_interp'
            [fitness ,error] = pol_interp(genome,fitness_mode_opts, calc_error);
            
            
    end
end


%mode = 'function_max'
function [fitness] = function_max(genome,fitness_mode_opts)
    
    %fitness_opts = {'function_max', a , b , @(x) f(x)}
    
    
    f = fitness_mode_opts{4}; 
    x = decode_ab(genome , length(genome) , fitness_mode_opts{2} , fitness_mode_opts{3});
    fitness = f(x);
    
    
end


%mode = 'pol_interp'%
function [fitness , error] = pol_interp(genome,fitness_mode_opts,calc_error)
    %fitness_opts = {'pol_interp',a,b,f,n};  
    %%%NEED TO ADD IF ROW OF GENOME REPEATED, FITNESS = 0%%%
    
%     if rank(genome) < size(genome,1)
%         fitness = 0;
%         return;
%     end
    
    f = fitness_mode_opts{4};
    n = fitness_mode_opts{5};
    %preallocation
    x = zeros(1,n);
    
    %length of each chromosome
    len = length(genome(1,:));
    
    for i=1:n
    x(i) = decode_ab(genome(i,:) , len , fitness_mode_opts{2} , fitness_mode_opts{3});
    end
    
    
    %get the polinomial coefficients
    p = polyfit(x,f(x),n-1);
    
    
    %define polinomial handle    
    pol =  @(y) evalpol(p,y);
    
    f_integral = @(y)  -exp(cos(y)).*(-1 + cos(y));
    
    
    %define function to be integrated
    h = @(y) abs(f(y) - pol(y));
    
    %for fitness to be positive and positively oriented, we apply - log(x  + 0.00001)
    
    pol_int = polyint(p);
    
    
    if n > 2
        pol_int_value = abs(f_integral(fitness_mode_opts{3})-evalpol(pol_int,fitness_mode_opts{3})  - f_integral(fitness_mode_opts{2}) + evalpol(pol_int,fitness_mode_opts{2}));
        fitness = pol_int_value;
        if calc_error == true;
            L1_norm = integral(h,fitness_mode_opts{2} , fitness_mode_opts{3}, 'RelTol',0,'AbsTol',1e-12);     
            error = L1_norm;
        else
            error = 'unknown';
        end
    else
        L1_norm = integral(h,fitness_mode_opts{2} , fitness_mode_opts{3}, 'RelTol',0,'AbsTol',1e-12);     
        fitness = L1_norm + 0.00001;
        if calc_error == true;
            error = L1_norm;
        else
            error = 'unknown';
        end
        
    end
    
    fitness =100 - log(fitness);    
    %disp(fitness)
    
%   we set fitness to 0 for negative fitness values
%     if fitness < 0
%         fitness = 0;
%     end
    

end





