function [ population ] = main( txtfile )

%we want no warnings on badly conditioned polinomials
warning('off','MATLAB:polyfit:RepeatedPointsOrRescale')


%Read sample Individual's genome
clear nextline
mode         = nextline(txtfile);
fitness_opts = eval(nextline(txtfile));


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%create fitness_mode_opts --> {'mode',%fitnessopts%}
fitness_mode_opts = {mode,fitness_opts{:}};
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

C_data            = eval(nextline(txtfile));
popsize           = eval(nextline(txtfile));
imax              = eval(nextline(txtfile));

a = fitness_mode_opts{2};
b = fitness_mode_opts{3};
f = fitness_mode_opts{4};
n = fitness_mode_opts{5};



%Initialize population with randpop, and write mode_fitness_opts on popultion
population = randpop(C_data,popsize,fitness_mode_opts);

hold all

%we create two points to name the legends, make room for legends, and
%preallocate x axis


legend('Max. fitness','Mean fitness','Location','southeast')
for i = 1:imax
    
    matingpool = select(population);
    matedpool = crossover(matingpool);
    population.pop = mutate(matedpool);    
    scatter(i,population.bestfitness,'.','MarkerEdgeColor','red')
    scatter(i,population.meanfitness,'.','MarkerEdgeColor','blue')
    drawnow
    
    
end
%plot function and found maxima
figure
%preallocate vector of positions of interpolating points
x = zeros(1,n);
%get best interpolating points
for i=1:n
    x(i) = decode_ab(population.bestpopindividual.chrompack.genome(i,:),size(C_data,2),a,b);
end
hold all


%plot f function
plot(a:(b-a)/1000:b,f(a:(b-a)/1000:b))

%plot interpolating polinomial
%get the polinomial coefficients
 p = polyfit(x,f(x),n-1);
%define polinomial handle    
pol =  @(y) evalpol(p,y);

[~,error] = calculatefitness(population.bestpopindividual.chrompack.genome,fitness_mode_opts,true);



plot(x,f(x),'go', 'markersize', 5);

text(0,0,{'error: ',error});

plot(a:(b-a)/100000:b, pol(a:(b-a)/100000:b))





legend('f','interpolating points','ga interpolation','Location','southeast')

hold off
end

