function [ pop ] = randpop( C , popsize , mode )
%RANDPOP generate random population drom a given individual example
%Input-->
%   C       ---> binary code, as an example of the individuals to generate
%   popsize ---> the number of individuals to be created     
%
%Output--> 
%   pop_of_individuals ---> randomly initialized population


%we extract examples size
nchrom = mode{5};
chromlength = size(C,2);

%- we create a matrix of random genomes, concatenated one next to the other
%- using mat2cell, we slice this concatenation of genomes to cells with one
%genome each
 
cell_of_genomes = mat2cell(randi([0,1],nchrom,chromlength * popsize),nchrom,ones(1,popsize)*chromlength);

%convert genomes to chromosomes,and chromosomes to individuals 
cell_of_individuals = (cellfun(@(x) Individual(Chrompack(x)), cell_of_genomes,'UniformOutput',false));

%convert cell aray to normal array
array_of_individuals = [cell_of_individuals{:}];

pop = Population(array_of_individuals , mode);

end
